// MyVarMem.h: MyVarMem NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MYVARMEM_H__766E6305_F9E0_4507_994C_9FF3762A6EE8__INCLUDED_)
#define AFX_MYVARMEM_H__766E6305_F9E0_4507_994C_9FF3762A6EE8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/* ****************************************************************************

  ϒNX
  KvɉĎIɃgĂ܂B
  E	m_nBlockSize = 512 ɐݒ肳Ă܂B

  {\
  f[^     :|<...  data  ...>|\0|
  f[^     :|<-m_nBufferLen->|
  ̈       :|<-          512*n            ->|

  EI[ɂ|\0|tĂ܂B
  EXbhZ[tł͂܂B

**************************************************************************** */

class MyVarMem 
{
public:
	MyVarMem();
	virtual ~MyVarMem();

private:
	void*	m_pBuffer;		// w|C^
	size_t	m_nBufferLen;	// ݂̃(Alloc̈Ƃ͈Ⴂ܂)
	int		m_nBlockSize;	// 擾̍ۂ̃y[WEłB

public:
	
	void* GetBuffer()	const	{return m_pBuffer;}
	size_t GetLength()	const	{return m_nBufferLen;}

	size_t AddHead( const void* pAddData, size_t nDataLen);
	size_t Add( const void* pAddData, size_t nDataLen);
	
	size_t AddHead(MyVarMem* pH)	{return AddHead(pH->GetBuffer(), pH->GetLength());}
	size_t Add(MyVarMem* pH)		{return Add(pH->GetBuffer(), pH->GetLength());}
	
	size_t Add(const char* pszStr);

	virtual void Clear();
	virtual int IsEmpty()	{return (m_pBuffer==NULL)?1:0;}

	operator const void*()	{return (const void*)m_pBuffer;}
	operator const char*()	{return (const char*)m_pBuffer;}
};
#endif // !defined(AFX_MYVARMEM_H__766E6305_F9E0_4507_994C_9FF3762A6EE8__INCLUDED_)
