// MyProxy.cpp: MyProxy NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MyVarMem.h"
#include "MyProxy.h"
#define		SOCKET_HEAD_BUF	(1024*128)
#define		HEADER_LINE_MAX	1024
//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////
extern fIsTextPrint;
extern fPostDataExpand;

MyProxy::MyProxy()
{
	m_dwRecvTimeOut = 90000;
	memset( &m_hrHttpReq, 0, sizeof(HTTP_REQUEST) );

}

MyProxy::~MyProxy()
{

}


//-----------------------------------------------------------------------------
//	@detail
//		HTTPNGXg͂AHTTPXe[^Xm
//	@param
//		
//	@return
//		0̓\Pbg֘AG[łȏʐMoȂ
//		ȊOHTTPXe[^XԂ
//-----------------------------------------------------------------------------
int MyProxy::RecvRequest(/* int* pbClose */)
{
	char szHeadBuf[SOCKET_HEAD_BUF];
	m_hReqHead.Clear();
	m_hReqBody.Clear();
	char* pReq = NULL;

	//-------------------------------------------
	// MvZX
	//-------------------------------------------

	// Get http header
	DWORD	dwStartTime = GetTickCount();
	MyVarMem hReq;// = new MyVarMem;

	int nRecvLen;
	int flag = 1;
	while(1)
	{
		char*	p;
		memset(szHeadBuf, 0, SOCKET_HEAD_BUF);
		nRecvLen = RecvData(szHeadBuf, SOCKET_HEAD_BUF);

		if( nRecvLen == SOCKET_ERROR )		//*** \PbgG[
		{
			Close();
			return 0;
		}
		else if( nRecvLen > 0 )				//*** M
		{
			// RFC2626 sec.5
			hReq.Add((void*)szHeadBuf, nRecvLen);

			// wb_[I
			const char* pszReqHeadBuf = (const char*)hReq.GetBuffer();

			if( pszReqHeadBuf == NULL )
				return 0;
			p = strstr(pszReqHeadBuf, "\r\n\r\n");

			// wb_[I
			if( p != NULL )
			{
				// wb_[m_ReqHeadɒǉ
				int nHeaderLen = ((p+4) - pszReqHeadBuf);
				m_hReqHead.Add(hReq.GetBuffer(), nHeaderLen);
				
				// ǂ݂m_hReqBodyɒǉ
				int nDrop = hReq.GetLength() - nHeaderLen;
				if( nDrop > 0 )
					m_hReqBody.Add( (p+4), nDrop);

				hReq.Clear();

				//-------------------------------------------------------------
				// NGXgwb_̈S̃`FbN
				// SẴCHEADER_LINE_MAXoCgȓłȂƃ_
				//-------------------------------------------------------------
				pReq = (char*)(const char*)m_hReqHead;

				if( pReq == NULL )
					return 0;

				for( int count = 0; *pReq; pReq++, count++ )
				{
					if( count > HEADER_LINE_MAX )
						return 400;	// Bad Request

					if( *pReq == '\r' )
					{
						count = 0;

						if( pReq[1] == '\0' )
							return 400;		// Bad Request
						
						pReq += 2;
						continue;
					}
				}

				// sڂ𕪉
				int ret;
				ret = WorkParseRequestLine((const char*)m_hReqHead);
				if( ret != 200 ) return ret;

				// sڈȍ~𕪉
				// if( NULL == (const char*)m_hReqHead )
				ret = WorkParseRequestHeader((const char*)m_hReqHead);
				if( ret != 200 ) return ret;

				// HTTP/1.1  Host:wb_K{
				// @RFC2616 sec.19.6.1.1
				if( !strcmp( m_hrHttpReq.szHttpVer, "HTTP/1.1" ) &&
					!m_hashReqHeader.GetValue("Host:") )
					return 400;	// Bad Request

				break;
			}
		}

		// timeout check.
		DWORD dwSlipTime = (GetTickCount() - dwStartTime);
		
		// max 90sec. 47 days problem.
		if(	dwSlipTime > m_dwRecvTimeOut || dwSlipTime > 90000 )
		{
			//m_bKeepAlive = FALSE;
			return 504;	// Gateway Time-out
		}

	}	// end of while

	return 200;

}

//-----------------------------------------------------------------------------
//	@detail
//
//	@param
//		
//	@return
//
//-----------------------------------------------------------------------------
int MyProxy::RecvWebResponse(/* int* pbClose */)
{
	char szHeadBuf[SOCKET_HEAD_BUF];
	m_hReqHead.Clear();
	m_hReqBody.Clear();
	char* pReq = NULL;

	//-------------------------------------------
	// MvZX
	//-------------------------------------------

	// Get http header
	DWORD	dwStartTime = GetTickCount();
	MyVarMem hReq;// = new MyVarMem;

	int nRecvLen;
	int flag = 1;
	while(1)
	{
		char*	p;
		nRecvLen = RecvData(szHeadBuf, SOCKET_HEAD_BUF);

		if( nRecvLen == SOCKET_ERROR )		//*** \PbgG[
		{
			Close();
			return SOCKET_ERROR;
		}
		else if( nRecvLen > 0 )				//*** M
		{
			// RFC2626 sec.5
			hReq.Add((void*)szHeadBuf, nRecvLen);

			// wb_[I
			const char* pszReqHeadBuf = (const char*)hReq.GetBuffer();
			if( p = strstr(pszReqHeadBuf, "\r\n\r\n") )
			{
				*p = '\0';
				p += 4;
			}
			else if(p = strstr(pszReqHeadBuf, "\n\n"))
			{
				*p = '\0';
				p += 2;
			}
			else if( p = strstr(pszReqHeadBuf, "\r\r") )
			{
				*p = '\0';
				p += 2;
			}
			else
			{
				continue;
			}

			// wb_[I
			// wb_[m_ReqHeadɒǉ
			int nHeaderLen = (p - pszReqHeadBuf);
			m_hReqHead.Add(hReq.GetBuffer(), nHeaderLen);
			
			// ǂ݂m_hReqBodyɒǉ
			int nDrop = hReq.GetLength() - nHeaderLen;
			if( nDrop > 0 )
				m_hReqBody.Add( p, nDrop);

			hReq.Clear();

			//-------------------------------------------------------------
			// NGXgwb_̈S̃`FbN
			// SẴCHEADER_LINE_MAXoCgȓłȂƃ_
			//-------------------------------------------------------------
			pReq = (char*)(const char*)m_hReqHead;

			for( int count = 0; *pReq; pReq++, count++ )
			{
				if( count > HEADER_LINE_MAX )
					return SOCKET_ERROR;			// Bad Request

				if( *pReq == '\r' )
				{
					count = 0;

					if( pReq[1] == '\0' )
						return SOCKET_ERROR;		// Bad Request
					
					pReq += 2;
					continue;
				}

				// sڂ𕪉
				int ret;
				//ret = WorkParseRequestLine((const char*)m_hReqHead);
				//if( ret != 200 ) return ret;

				// sڈȍ~𕪉
				ret = WorkParseRequestHeader((const char*)m_hReqHead);
				//if( ret != 200 ) return ret;

				/*
				// HTTP/1.1  Host:wb_K{
				// @RFC2616 sec.19.6.1.1
				if( !strcmp( m_hrHttpReq.szHttpVer, "HTTP/1.1" ) &&
					!m_hashReqHeader.GetValue("Host:") )
					return 400;	// Bad Request
				*/
				return  m_hReqHead.GetLength() + m_hReqBody.GetLength();
			}
		}

		// timeout check.
		DWORD dwSlipTime = (GetTickCount() - dwStartTime);
		
		// max 90sec. 47 days problem.
		if(	dwSlipTime > m_dwRecvTimeOut || dwSlipTime > 90000 )
		{
			//m_bKeepAlive = FALSE;
			return SOCKET_ERROR;	// Gateway Time-out
		}

	}	// end of while

	return m_hReqHead.GetLength() + m_hReqBody.GetLength();

}

//-----------------------------------------------------------------------------
//	@detail
//		NCAg{fB̎c󂯎
//		T[oɓ
//		T[of[^󂯎
//	@param
//		
//	@return
//-----------------------------------------------------------------------------
int MyProxy::RecvAndSendBody(MySock* pDst)
{
	char	szTmp[SOCKET_HEAD_BUF+1];
	DWORD	dwStartTime = GetTickCount();
	DWORD	dwSlipTime = 0;
	char	szBodyBuf[SOCKET_HEAD_BUF];

	char* p = NULL;
	long lTotalSize = 0;
	long lContentLength;

	int bBinary = 0;

	// NCAg --> T[osf[^
	if( m_hrHttpReq.HttpCmd == HTTPPOST )
	{
		fIsTextPrint = fPostDataExpand;
		p = m_hashReqHeader.GetValueI("Content-type:");
	}

	
	p = m_hashReqHeader.GetValueI("Content-Length:");
	if( p == NULL )
	{
		// s̏ꍇ̏
		printf("[IPROXY] Contents-Length is nothing.\n");
		p = m_hashReqHeader.GetValueI("Content-type:");
		if( p != NULL )
		{
			if( 0 == strncmp(p, "text/", 5 ) )
			{
				// text 256MB܂Ŏă^CAEgorؒf҂
				lContentLength = 0xFFFFFFF;
				bBinary = 0;
			}
			else
			{
				// textȊO
				bBinary = 1;
			}
		}
		else
		{
			printf("[IPROXY] Content-type is nothing.\n");
			bBinary = 1;
		}
	}
	else
	{
		lContentLength = atol(p);

		if( lContentLength < 0 )
		{
			printf("[IPROXY] ContentLength = [%s].\n", p);
			return 0;	// Bad Request
		}
	}
	int nRecvLen = 0;
	int nSendLen = 0;

	// cĂ镪Ƃ肠
	if( m_hReqBody.GetLength() > 0 )
	{
		nSendLen = pDst->SendData((char*)m_hReqBody.GetBuffer(), m_hReqBody.GetLength() );
		
		if( fIsTextPrint )
		{
			char* p = (char*)m_hReqBody.GetBuffer();
			if( p )
			{
				if(fIsTextPrint/* && (bBinary = 0)*/ )
				{
					strncpy(szTmp, p, m_hReqBody.GetLength());
					szTmp[m_hReqBody.GetLength()] = '\0';
					puts(szTmp);
				}
			}
		}

		lTotalSize += nSendLen;
		dwSlipTime = GetTickCount() - dwStartTime;
		printf("TRANSPORTING:%8u/%8u[byte] TIME:%4u/%4u[msec]%c",lTotalSize,
			(lContentLength != 0xFFFFFFF)? lContentLength : 0, dwSlipTime, m_dwRecvTimeOut, 0x0d);
		m_hReqBody.Clear();
	}

	while(lTotalSize < lContentLength)
	{
		memset(szBodyBuf, 0, SOCKET_HEAD_BUF);
		nRecvLen = RecvData(szBodyBuf, SOCKET_HEAD_BUF);
	
		// \PbgG[
		if( nRecvLen == SOCKET_ERROR )
		{
			m_hReqBody.Clear();
			return -1;
		}
		else
		{
			lTotalSize += nRecvLen;
		}

		nSendLen = pDst->SendData(szBodyBuf, nRecvLen);
		
		// timeout check.
		dwSlipTime = GetTickCount() - dwStartTime;
		if( dwSlipTime > m_dwRecvTimeOut )
		{
			printf("\n\n^CAEg܂I\n\n");
			return -1;	// Gateway Time-out
		}
		if( nSendLen > 0 && fIsTextPrint )
		{
			strncpy(szTmp, szBodyBuf, nSendLen);
			szTmp[nSendLen] = '\0';
			puts(szTmp);
		}
		else
		{
			printf("TRANSPORTING:%8u/%8u[byte] TIME:%4u/%4u[msec]/TimeOUT%c",lTotalSize,
				(lContentLength != 0xFFFFFFF)? lContentLength : 0, dwSlipTime, m_dwRecvTimeOut, 0x0d);
		}
	}
	printf("\n");
	return lTotalSize;
}


//-----------------------------------------------------------------------------
//	@detail
//		NGXgC𕪊
//	@param
//		
//	@return
//		400 sȃNGXg
//		200 I
//		500 InternalServerError
//		501 not implement
//	RFC2616 sec.5.1
//		Request-Line   = Method SP Request-URI SP HTTP-Version CRLF
//-----------------------------------------------------------------------------
int MyProxy::WorkParseRequestLine(const char* pSrc)
{
	if( pSrc == NULL )
		return 400;

	char szTmp1[HEADER_LINE_MAX],
		szTmp2[HEADER_LINE_MAX],
		szTmp3[HEADER_LINE_MAX];
	//-------------------------------------------
	// NGXgC̉
	//-------------------------------------------
	char* pReq = (char*)pSrc;
	
	//if( 3 != sscanf( pReq, "%s%s%s",szTmp1, szTmp2, szTmp3 ) )
	if( 3 > ParseRequestLine(pReq, szTmp1, szTmp2, szTmp3) )
		return 400;	// Bad Request

	strcpy(m_hrHttpReq.szHttpCmd, szTmp1);
	// R}h̏Ɖ
	if( !strcmp( szTmp1, "GET" ) )
	{
		m_hrHttpReq.HttpCmd = HTTPGET;
	}
	else if( !strcmp( szTmp1, "HEAD" ) )
	{
		m_hrHttpReq.HttpCmd = HTTPHEAD;
	}
	else if( !strcmp( szTmp1, "POST" ) )
	{
		m_hrHttpReq.HttpCmd = HTTPPOST;
	}
	else if( 
		!strcmp( szTmp1, "PUT" )	||
		!strcmp( szTmp1, "DELETE" )	||
		!strcmp( szTmp1, "TRACE" )	||
		!strcmp( szTmp1, "OPTIONS" )||
		!strcmp( szTmp1, "CONNECT" )||
		!strcmp( szTmp1, "LINK" )	||
		!strcmp( szTmp1, "UNLINK" )	)
	{
		m_hrHttpReq.HttpCmd = HTTPNOTIMPLEMENTED;
		return 501;	// Not Implemented
	}
	else
	{
		m_hrHttpReq.HttpCmd = HTTPUNKNOWN;
		return 400;	// Bad Request
	}


	//-------------------------------------------
	// HTTPversion̉
	//-------------------------------------------
	if( !strcmp( szTmp3, "HTTP/1.0" ) || !strcmp( szTmp3, "HTTP/1.1" ) )
	{
		strcpy(m_hrHttpReq.szHttpVer, szTmp3);
	}
	else
	{
		// sȃo[W̏ꍇAԓHTTP/1.0ɂ
		strcpy(m_hrHttpReq.szHttpVer, "HTTP/1.0");
		return 400;	// Bad Request
	}

	//-------------------------------------------
	// pX̉
	//-------------------------------------------
	char* pszPathFrom = szTmp2;
	char* pszUrlPath	= m_hrHttpReq.szUrlPath;
	char* pszPathTo = m_hrHttpReq.szFilePath;

	// URIhttp://servername/..../̃p^[̏ꍇ
	// @RFC2616 sec.5.1.2 absoluteURI
	// Host͐Ɖ肷B
	// ԈĂvNVB
	if( !strncmp( pszPathFrom, "http://", 7 ) )
	{
		// http://servername:80/path/
		pszPathFrom += 7;
		// -> servername:80/path/
		
		// PROXY
		char szServerName[MAX_PATH];
		memset(szServerName, 0, MAX_PATH);
		char* pszServerNameStart = pszPathFrom;

		if( NULL == (pszPathFrom = strstr(pszPathFrom, "/")) )
		{
			return 400;	// Bad Request
		}

		if( *pszPathFrom != '/' )
		{
			return 400;	// Bad Request
		}

		strncpy( m_hrHttpReq.szUrlPath, pszPathFrom, MAX_PATH );

		// PROXY
		if( 2 == sscanf( pszServerNameStart, "%[^/]", szServerName ) )
		m_hashReqHeader.Set("Host:", szServerName);
	}


	return 200;
}

//-----------------------------------------------------------------------------
//	@detail
//		NGXgC𕪉
//	@param
//
//	@return
//		擾łZeX̐
//-----------------------------------------------------------------------------
int MyProxy::ParseRequestLine( const char* pReq, char* szCmd, char* szPath, char* szHttpVer )
{
	if( pReq == NULL || *pReq == '\0' )
		return 0;

	// szCmd
	while( *pReq == ' ' || *pReq == '\t' )	pReq++;

	while( *pReq != ' ' && *pReq != '\t' )
	{
		if( *pReq == '\0' || *pReq == '\r' || *pReq == '\n' )
		{
			*szCmd = '\0';
			return 1;
		}
		*szCmd++ = *pReq++;
	}
	*szCmd = '\0';
	pReq++;

	// szPath
	while( *pReq == ' ' || *pReq == '\t' )	pReq++;

	while( *pReq != ' ' && *pReq != '\t' )
	{
		if( *pReq == '\0' || *pReq == '\r' || *pReq == '\n' )
		{
			*szPath = '\0';
			strcpy(szHttpVer, "HTTP/1.0");
			return 3;
		}
		*szPath++ = *pReq++;
	}
	*szPath = '\0';
	pReq++;

	// szHttpVer
	while( *pReq == ' ' || *pReq == '\t' )	pReq++;

	while( *pReq != '\0' && *pReq != '\r' && *pReq != '\n' )
	{
		*szHttpVer++ = *pReq++;
	}
	*szHttpVer = '\0';
	return 3;

}


//-----------------------------------------------------------------------------
//	@detail
//		NGXgwb_[𕪊Am_hashReqHeaderɓĂ
//	@param
//		wb_[
//	@return
//		400 sȃNGXg
//		200 I
//		500 InternalServerError
//
//	@RFC2616 sec.5
//-----------------------------------------------------------------------------
int MyProxy::WorkParseRequestHeader(const char* pSrc)
{
	if( pSrc == NULL )
		return 400;
	//-------------------------------------------
	// NGXgwb_tB[h̉
	//-------------------------------------------
	char szReqKey[HEADER_LINE_MAX], szReqValue[HEADER_LINE_MAX];

	char* pReq = (char*)pSrc;
	// NGXgC(GET /index.html HTTP/1.0 ...)̎̍s
	if( NULL == ( pReq = strstr( pReq, "\r\n" )) )
	{
		return 400;	// Bad Request
	}
	pReq += 2;
	
	while( *pReq != '\0' )
	{
		if( *pReq == '\r' )	// NGXgwb_[̏I
			break;
		
		//if( 2 == sscanf( (const char*)pReq, "%s %[^\r]", szReqKey, szReqValue ) )
		if( 2 == ParseRequestHeader( (const char*)pReq, szReqKey, szReqValue ) )
		{
			// ǉ̎s
			if( !m_hashReqHeader.Set(szReqKey, szReqValue) ||
				m_hashReqHeader.GetLength() > 4000)
			return 500;
		}

		if( NULL == (pReq = strstr( pReq, "\r\n" )) )
			return 400;	// Bad Request

		pReq += 2;
	}
	return 200;
}

//-----------------------------------------------------------------------------
//	@detail
//		NGXgwb_[𕪊
//	@param
//	@return
//		擾łZeX̐
//-----------------------------------------------------------------------------
int MyProxy::ParseRequestHeader( const char* pReq, char* szReqKey, char* szReqValue )
{
	if( pReq == NULL || *pReq == '\0' )
		return 0;

	while( *pReq != ' ' && *pReq != '\t' )
	{
		if( *pReq == '\0' || *pReq == '\r' || *pReq == '\n' )
		{
			*szReqKey = '\0';
			return 1;
		}
		*szReqKey++ = *pReq++;
	}
	*szReqKey = '\0';
	*pReq++;

	while( *pReq != '\0' && *pReq != '\r'  && *pReq != '\n')
	{
		*szReqValue++ = *pReq++;
	}
	*szReqValue = '\0';
	return 2;
}
