// MyProxy.h: MyProxy NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MYPROXY_H__4B1A4D88_9E42_481D_ABEF_9C89C520B041__INCLUDED_)
#define AFX_MYPROXY_H__4B1A4D88_9E42_481D_ABEF_9C89C520B041__INCLUDED_

#include "MyVarMem.h"	// ClassView ɂĒǉ܂B
#include "MyHash.h"	// ClassView ɂĒǉ܂B
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MySock.h"

//-----------------------------------------------
enum HTTPCMD
{
	HTTPUNKNOWN = 0,	// bad request
	HTTPHEAD,			// Implemented
	HTTPGET,			// Implemented
	HTTPPOST,
	/* Not Implemented
	HTTPPUT,
	HTTPDELETE,
	HTTPTRACE,
	HTTPOPTIONS,
	HTTPCONNECT,
	HTTPLINK,
	HTTPUNLINK
	*/
	HTTPNOTIMPLEMENTED
};
//-----------------------------------------------
// HTTP_REQUEST
// NGXgǂݎW
//-----------------------------------------------
typedef struct tagHTTP_REQUEST
{
	// Request line
	HTTPCMD			HttpCmd;				// GET, HEAD, POST,...
	char			szHttpCmd[MAX_PATH];
	char			szUrlPath[MAX_PATH];	// Url̃pX
	char			szFilePath[MAX_PATH];	// t@C̃pX
	char			szHttpVer[16];			// HTTP̃o[W
	sockaddr_in*	psaRemoteHost;			// [gzXg

} HTTP_REQUEST, *LPHTTP_REQUEST;




class MyProxy	:	public MySock
{
public:
	DWORD			m_dwRecvTimeOut;
	HTTP_REQUEST	m_hrHttpReq;	// HTTP_REQUEST
	MyHash			m_hashReqHeader;
	MyVarMem		m_hReqBody;
	MyVarMem		m_hReqHead;
	int				WorkParseRequestLine(const char* pSrc);
	int				ParseRequestLine( const char* pReq, char* szCmd, char* szPath, char* szHttpVer );
	int				WorkParseRequestHeader(const char* pSrc);
	int				ParseRequestHeader( const char* pReq, char* szReqKey, char* szReqValue );

	int				RecvRequest(/* int* pbClose */);
	int				RecvWebResponse(/* int* pbClose */);
	int				RecvAndSendBody(MySock* pDst);

	MyProxy();
	virtual ~MyProxy();

};

#endif // !defined(AFX_MYPROXY_H__4B1A4D88_9E42_481D_ABEF_9C89C520B041__INCLUDED_)
